function [G, X0, Y0] = planted_dbks(M, N, k1, k2,p, q)

% Generates a N-node graph with k clusters of size at least rmin.
% Start with all-ones blocks representing cliques indexed by each clusters and then
% delete clique edges, and add nonclique edges independently with probability p.

%% Initialize G:
G = rand(M, N); 

% Add noise edge if Gij < p.
G = ceil(G - (1-p));


%% Insert edges for planted dense subgraph.



% Make dense block
% Get G.
temp = rand(k1,k2);
    G(1:k1, 1:k2) = ceil(temp - q);    
    
% Get X0
X0 = zeros(M,N); % Initialize X0.
X0(1:k1, 1:k2) = ones(k1, k2); % Fill in dense block.

% Make Y0.
Y0 = zeros(M, N);
Y0(1:k1, 1:k2) = ones(k1,k2) - G(1:k1, 1:k2); Y0 = -1*Y0;



