function [G, X0, Y0] = planted_dks(N,k,p, q)

% Generates a N-node graph with k clusters of size at least rmin.
% Start with all-ones blocks representing cliques indexed by each clusters and then
% delete clique edges, and add nonclique edges independently with probability p.

%% Initialize G:
G = rand(N); G = 0.5*(G + G');

% Add noise edge if Gij < p.
G = ceil(G - (1-p));


%% Insert edges for planted dense subgraph.



% Make dense block
% Get G.
temp = rand(k); temp = 0.5*(temp + temp');
    G(1:k, 1:k) = ceil(temp - q);    
    
% Replace diagonal of G with ones.
G = G - diag(diag(G)) + eye(N);

% Get X0
X0 = zeros(N); % Initialize X0.
X0(1:k, 1:k) = ones(k); % Fill in dense block.

Y0 = zeros(N);
Y0(1:k, 1:k) = ones(k) - G(1:k, 1:k); Y0 = -1*Y0;




This work is licensed under the Creative Commons Attribution-NonCommercial 3.0 Unported License. To view a copy of this license, visit http://creativecommons.org/licenses/by-nc/3.0/ or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.